/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { ColorScale } from "./ColorScale";
import { runOn, delegateRemove, delegateCombine, typeCast, Point_$type, markType, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { FastItemIntColumn } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { SeriesView } from "./SeriesView";
import { TriangleRasterizer } from "./TriangleRasterizer";
import { ScalerParams } from "./ScalerParams";
import { ObservableColorCollection } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { ColorUtil } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { CustomPaletteColorScale } from "./CustomPaletteColorScale";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, intDivide } from "igniteui-react-core";
import { boxArray$1 } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var ScatterAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterAreaSeries, _super);
    function ScatterAreaSeries() {
        var _this = _super.call(this) || this;
        _this.vw = null;
        _this.v1 = null;
        _this.vu = null;
        _this.vv = null;
        FastItemIntColumn.m();
        _this.ab = ScatterAreaSeries.$;
        return _this;
    }
    ScatterAreaSeries.prototype.get_d8 = function () {
        return true;
    };
    Object.defineProperty(ScatterAreaSeries.prototype, "vy", {
        get: function () {
            return this.vw;
        },
        set: function (a) {
            var b = this.vw != a;
            if (b) {
                var c = this.vw;
                if (this.vw != null) {
                    var d = this.vw;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.wf));
                }
                this.vw = a;
                if (this.vw != null) {
                    var e = this.vw;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.wf));
                }
                this.raisePropertyChanged("ColorScale", c, this.vw);
            }
        },
        enumerable: false,
        configurable: true
    });
    ScatterAreaSeries.prototype.wf = function (a, b) {
        this.wh();
        this.pp(false);
    };
    ScatterAreaSeries.prototype.ju = function (a, b) {
        var c = this.lv(b);
        if (c == ScatterAreaSeries.$$p[3]) {
            return this.jv(a, b, this.wa);
        }
        return _super.prototype.ju.call(this, a, b);
    };
    Object.defineProperty(ScatterAreaSeries.prototype, "v2", {
        get: function () {
            return this.v1;
        },
        set: function (a) {
            var b = this.v2 != a;
            if (b) {
                var c = this.v2;
                this.v1 = a;
                this.raisePropertyChanged("ColorColumn", c, this.v2);
            }
        },
        enumerable: false,
        configurable: true
    });
    ScatterAreaSeries.prototype.get_gf = function () {
        return true;
    };
    ScatterAreaSeries.prototype.set_gf = function (a) {
        _super.prototype.set_gf.call(this, a);
    };
    ScatterAreaSeries.prototype.o8 = function (a, b, c, d) {
        _super.prototype.o8.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.v2);
                    this.v2 = null;
                }
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.v2 = this.c3(this.wa);
                }
                this.pp(this.fq && c != null);
                break;
            case ScatterAreaSeries.$$p[3]:
                if (this.c6 != null) {
                    this.c6.deregisterColumn(this.v2);
                    this.v2 = this.c3(this.wa);
                }
                this.pp(false);
                this.ol();
                break;
            case "ColorScale":
                this.wh();
                this.pp(false);
                this.ol();
                break;
        }
    };
    ScatterAreaSeries.prototype.pq = function (a) {
        _super.prototype.pq.call(this, a);
        this.wg(this.cj);
    };
    ScatterAreaSeries.prototype.po = function (a, b, c, d, e) {
        _super.prototype.po.call(this, a, b, c, d, e);
        var f = this.a7.a$h.item(d);
        f.a3(c);
        if (this.dl(f)) {
            return;
        }
        this.wg(f);
    };
    ScatterAreaSeries.prototype.wg = function (a) {
        if (this.dl(a)) {
            return;
        }
        var b;
        var c;
        var d = a.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        var e = a;
        var f = null;
        var g = null;
        var h = this.t1;
        var i = this.t2;
        var j = this.getEffectiveViewport1(a);
        var k = new ScalerParams(1, b, c, h.ch);
        k.c = j;
        var l = new ScalerParams(1, b, c, i.ch);
        l.c = j;
        g = this.v0(a, k, l);
        if (g != null) {
            e.cb(g);
        }
        else {
            e.ce(f);
        }
    };
    ScatterAreaSeries.prototype.wd = function (a) {
        var b;
        var c;
        var d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        var e = truncate(Math.round(b.width)) * truncate(Math.round(b.height));
        var f = a.b3;
        if (f == null || f.length != e) {
            f = new Array(e);
            for (var g = 0; g < e; g++) {
                f[g] = 0;
            }
        }
        else {
            for (var h = 0; h < e; h++) {
                f[h] = 0;
            }
        }
        a.b3 = f;
    };
    ScatterAreaSeries.prototype.jr = function (a) {
        var b = truncate(Math.round(this.tw.width));
        var c = truncate(Math.round(this.tw.height));
        var d = this.cj.b3;
        if (d == null || d.length != (b * c) || this.ub == null || this.ub.count < 1 || this.uc == null || this.uc.count < 1 || this.ud == null || this.ud.count < 1) {
            return null;
        }
        var e = this.cy.t3;
        var f = (a.x - e.left) / e.width;
        var g = (a.y - e.top) / e.height;
        var h = truncate(Math.round(b * f));
        var i = truncate(Math.round(c * g));
        var j = (b * i) + h;
        if (j < 0 || j > d.length - 1) {
            return null;
        }
        var k = d[j] - 1;
        if (k < 0 || k > this.ub.count) {
            return null;
        }
        var l = this.vu.length;
        var m = this.ub.item(k);
        var n = this.uc.item(k);
        var o = this.ud.item(k);
        if ((m >= l) || (n >= l) || (o >= l)) {
            return null;
        }
        var p = (this.vu[m] - this.tw.left) / this.tw.width;
        var q = (this.vv[m] - this.tw.top) / this.tw.height;
        var r = (this.vu[n] - this.tw.left) / this.tw.width;
        var s = (this.vv[n] - this.tw.top) / this.tw.height;
        var t = (this.vu[o] - this.tw.left) / this.tw.width;
        var u = (this.vv[o] - this.tw.top) / this.tw.height;
        var v = Math.pow(p - f, 2) + Math.pow(q - g, 2);
        var w = Math.pow(r - f, 2) + Math.pow(s - g, 2);
        var x = Math.pow(t - f, 2) + Math.pow(u - g, 2);
        if (v < w && v < x) {
            return this.c6.item(m);
        }
        if (w < v && w < x) {
            return this.c6.item(n);
        }
        if (x < v && x < w) {
            return this.c6.item(o);
        }
        return this.c6.item(m);
    };
    ScatterAreaSeries.prototype.v0 = function (a, b, c) {
        var d;
        var e;
        var f = a.getViewInfo(e, d);
        e = f.p0;
        d = f.p1;
        e = new Rect(0, 0, 0, e.width, e.height);
        b = new ScalerParams(0, b.e, e, b.a, b.c);
        c = new ScalerParams(0, c.e, e, c.a, c.c);
        c.b = this.h2();
        var g = a;
        var h = this.t1;
        var i = this.t2;
        var j = this.ub.count;
        var k;
        var xArr_ = this.ue.asArray();
        k = (xArr_.slice(0));
        var l;
        var yArr_ = this.uf.asArray();
        l = (yArr_.slice(0));
        var m = this.v2.asArray();
        var n = this.ub.asArray();
        var o = this.uc.asArray();
        var p = this.ud.asArray();
        this.vu = k;
        this.vv = l;
        h.hn(boxArray$1(k), 0, k.length, b);
        i.hn(boxArray$1(l), 0, l.length, c);
        var q = this.vx;
        var r = g.b5(b.d, q, this.v2);
        var s = e.top;
        var t = e.left;
        var u = e.right;
        var v = e.bottom;
        var w;
        var x;
        var y;
        var z;
        this.wd(g);
        var aa = g.b3;
        var ab = k.length;
        for (var ac = 0; ac < j; ac++) {
            var ad = n[ac];
            var ae = o[ac];
            var af = p[ac];
            if ((ad >= ab) || (ae >= ab) || (af >= ab) || (ad < 0) || (ae < 0) || (af < 0)) {
                continue;
            }
            var ag = k[ad];
            var ah = l[ad];
            var ai = { $type: Point_$type, x: ag, y: ah };
            var aj = k[ae];
            var ak = l[ae];
            var al = { $type: Point_$type, x: aj, y: ak };
            var am = k[af];
            var an = l[af];
            var ao = { $type: Point_$type, x: am, y: an };
            w = al.y < ao.y ? al.y : ao.y;
            w = ai.y < w ? ai.y : w;
            x = al.y > ao.y ? al.y : ao.y;
            x = ai.y > x ? ai.y : x;
            y = al.x < ao.x ? al.x : ao.x;
            y = ai.x < y ? ai.x : y;
            z = al.x > ao.x ? al.x : ao.x;
            z = ai.x > z ? ai.x : z;
            if (w < v && x > s && y < u && z > t) {
                var ap = m[ad];
                var aq = m[ae];
                var ar = m[af];
                r.p(ac, aa, ai, al, ao, ap, aq, ar);
            }
        }
        return r;
    };
    ScatterAreaSeries.prototype.v3 = function () {
        var a = new Color();
        var b = this.ss;
        if (b == null) {
            a = ColorUtil.r("#000000");
        }
        else {
            a = ColorUtil.q(b);
        }
        var c = new ObservableColorCollection();
        c.add(ColorUtil.v(a, -0.5));
        c.add(a);
        return c;
    };
    ScatterAreaSeries.prototype.wh = function () {
        var _this = this;
        var a = this.vy;
        if (a == null) {
            a = ((function () {
                var $ret = new CustomPaletteColorScale();
                $ret.palette = _this.v3();
                $ret.interpolationMode = 2;
                return $ret;
            })());
        }
        else if (typeCast(CustomPaletteColorScale.$, a) !== null) {
            var b = a;
            if (b.palette == null || b.palette.count == 0) {
                b.palette = this.v3();
            }
            a = b;
        }
        var c = new ObservableColorCollection();
        if (typeCast(CustomPaletteColorScale.$, a) !== null) {
            c = a.palette;
        }
        else {
            c = this.v3();
        }
        this.vx = a;
    };
    ScatterAreaSeries.prototype.qd = function () {
        _super.prototype.qd.call(this);
        this.wh();
    };
    ScatterAreaSeries.prototype.nj = function (a, b) {
        _super.prototype.nj.call(this, a, b);
        var c = b;
        c.ca();
    };
    ScatterAreaSeries.prototype.cg = function () {
        return new ScatterAreaSeriesView(this);
    };
    ScatterAreaSeries.prototype.o0 = function (a) {
        _super.prototype.o0.call(this, a);
        this.vz = typeCast(ScatterAreaSeriesView.$, a);
    };
    ScatterAreaSeries.prototype.we = function (a) {
        if (this.vz != null) {
            this.vz.b9(a);
        }
    };
    ScatterAreaSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.jr(c);
        var e = d == null ? NaN : this.h1(d, "XMemberPath");
        var f = d == null ? NaN : this.h1(d, "YMemberPath");
        var g = d == null ? NaN : this.h1(d, "ColorMemberPath");
        var h = new DataLegendSeriesValueInfo();
        h.l = e;
        h.a = 13;
        h.p = "X";
        h.q = this.u3 != null ? this.u3 : "X";
        h.r = this.uz != null ? this.uz : "X:";
        h.s = this.u1 != null ? this.u1 : "";
        var i = new DataLegendSeriesValueInfo();
        i.l = f;
        i.a = 14;
        i.p = "Y";
        i.q = this.vb != null ? this.vb : "Y";
        i.r = this.u7 != null ? this.u7 : "Y:";
        i.s = this.u9 != null ? this.u9 : "";
        var j = new DataLegendSeriesValueInfo();
        j.l = g;
        j.a = 0;
        j.p = "Value";
        j.q = this.wa != null ? this.wa : "Value";
        j.r = this.v6 != null ? this.v6 : "V:";
        j.s = this.v8 != null ? this.v8 : "";
        var k = new DataLegendSeriesContext();
        k.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(h);
            $ret.add(i);
            $ret.add(j);
            return $ret;
        })());
        k.b = this.aw();
        return k;
    };
    ScatterAreaSeries.$t = markType(ScatterAreaSeries, 'ScatterAreaSeries', ScatterTriangulationSeries.$);
    ScatterAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:vx:wi', [ColorScale.$, null], 'ColorMemberAsLegendLabel:v6:wj', [2, null], 'ColorMemberAsLegendUnit:v8:wk', [2, null], 'ColorMemberPath:wa:wl', [2, null]]);
    return ScatterAreaSeries;
}(ScatterTriangulationSeries));
export { ScatterAreaSeries };
/**
 * @hidden
 */
var ScatterAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterAreaSeriesView, _super);
    function ScatterAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.b4 = null;
        _this.b0 = null;
        _this.b8 = null;
        _this.b7 = null;
        _this.b6 = null;
        _this.b4 = a;
        return _this;
    }
    Object.defineProperty(ScatterAreaSeriesView.prototype, "b3", {
        get: function () {
            return this.b0;
        },
        set: function (a) {
            this.b0 = a;
        },
        enumerable: false,
        configurable: true
    });
    ScatterAreaSeriesView.prototype.cd = function (a, b) {
    };
    ScatterAreaSeriesView.prototype.b9 = function (a) {
    };
    ScatterAreaSeriesView.prototype.b1 = function () {
        return this.b2(true);
    };
    ScatterAreaSeriesView.prototype.b2 = function (a) {
        this.cc();
        var b = truncate(Math.round(this.bx.left));
        var c = truncate(Math.round(this.bx.left));
        var d = truncate(Math.round(this.bx.width));
        var e = truncate(Math.round(this.bx.height));
        var f = d.toString();
        var g = e.toString();
        if (this.b7.getAttribute("width") != f) {
            this.b7.setAttribute("width", d.toString());
        }
        if (this.b7.getAttribute("height") != g) {
            this.b7.setAttribute("height", e.toString());
        }
        var h = this.b6.h();
        if (a) {
            h.clearRect(0, 0, d, e);
        }
        this.b8 = h.getImageData(0, 0, d, e);
        var imageDataArray_ = this.b8.data;
        return imageDataArray_;
    };
    ScatterAreaSeriesView.prototype.cc = function () {
        if (this.b7 == null) {
            this.b7 = this.e.i4.createElement("canvas");
            var a = this.e.i4.get2DCanvasContext(this.b7);
            this.b6 = new RenderingContext(new CanvasViewRenderer(), a);
        }
    };
    ScatterAreaSeriesView.prototype.b5 = function (a, b, c) {
        var d = truncate(Math.round(this.bx.left));
        var e = truncate(Math.round(this.bx.left));
        var f = truncate(Math.round(this.bx.width));
        var g = truncate(Math.round(this.bx.height));
        return new TriangleRasterizer(this.b1(), b, c.minimum, c.maximum, c, f, g);
    };
    ScatterAreaSeriesView.prototype.cb = function (a) {
        this.ce(null);
    };
    ScatterAreaSeriesView.prototype.ca = function () {
        if (this.b6 != null) {
            this.b6.l(this.bx.left, this.bx.top, this.bx.width, this.bx.height);
        }
        this.as();
    };
    ScatterAreaSeriesView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (this.b7 == null) {
            return;
        }
        if (b) {
            var c = new Rectangle();
            c.n = this.bx.left;
            c.o = this.bx.top;
            c.width = this.bx.width;
            c.height = this.bx.height;
            c._fill = this.br();
            a.w(c);
        }
        else {
            var d = truncate(Math.round(this.bx.left));
            var e = truncate(Math.round(this.bx.top));
            var f = truncate(Math.round(this.bx.width));
            var g = truncate(Math.round(this.bx.height));
            a.n(this.b7.getNativeElement(), 1, d, e, f, g);
        }
    };
    ScatterAreaSeriesView.prototype.ce = function (a) {
        var b = truncate(Math.round(this.bx.left));
        var c = truncate(Math.round(this.bx.left));
        var d = truncate(Math.round(this.bx.width));
        var e = truncate(Math.round(this.bx.height));
        this.cc();
        this.b6.h().putImageData(this.b8, 0, 0);
        this.as();
    };
    ScatterAreaSeriesView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        var b = truncate(Math.round(this.bx.width));
        var c = truncate(Math.round(this.bx.height));
        var d = this.b2(false);
        if (d == null || d.length == 0) {
            this.e.a9.exportSeriesPixelsData(a, null, b, c);
            return;
        }
        var e = new Array(intDivide(d.length, 4));
        var f;
        for (var g = 0; g < intDivide(d.length, 4); g++) {
            f = g * 4;
            e[g] = d[f + 3] << 24 | d[f] << 16 | d[f + 1] << 8 | d[f + 2];
        }
        this.e.a9.exportSeriesPixelsData(a, e, b, c);
    };
    ScatterAreaSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a7.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.b4.title + "</span><br/><span>" + "(${item." + this.b4.u3 + "}, ${item." + this.b4.vb + "})</span>";
        if (!stringIsNullOrEmpty(this.b4.wa)) {
            a += "<span>, Value: ${item." + this.b4.wa + "}</span>";
        }
        a += "</div>";
        return a;
    };
    ScatterAreaSeriesView.$t = markType(ScatterAreaSeriesView, 'ScatterAreaSeriesView', SeriesView.$);
    return ScatterAreaSeriesView;
}(SeriesView));
export { ScatterAreaSeriesView };
